require("scripts/Player")
require("scripts/Menu")
require("scripts/Goal")
require("levels/Level_load")

function love.load()
    -- MY EYES mode (white background mode)
    MY_EYES = false
    -- stuff
    abc123 = false
    -- can't seem to get save files working :(
    savewrite = io.open("saves/save1.txt", "w")
    saveread = io.open("saves/save1.txt", "r")
    -- other stuff
    SPEEDRUN_MODE = false
    SPEEDRUN_TIMER = 0
    Level_num = 1
    love.graphics.setColor(1, 1, 1)
    Game_Music = love.audio.newSource("audio/music_1.mp3", "stream")
    Player_DeathSound = love.audio.newSource("audio/PlayerDeath.mp3", "static")
    Game_MainMusic = love.audio.newSource("audio/music_2.mp3", "stream")
    Player_Noise = love.audio.newSource("audio/PlayerHasHitWall.mp3", "static")
    Player_ISDED = love.audio.newSource("audio/PlayerHasDied.mp3", "static")
    Game_Music:play()
    Checkpoint_1 = false
    Checkpoint_2 = false
    Checkpoint_3 = false
    Checkpoint_4 = false
    ENDLEVEL = 26
    ICON = love.image.newImageData("assets/Icon/Icon.png")
    love.window.setIcon(ICON)
    love.window.setMode(800, 600, {resizable=false})
    Background_Black = love.graphics.newImage("assets/Background/background_black.png")
    Background_Red = love.graphics.newImage("assets/Background/background_red.png")
    Background_MYEYES = love.graphics.newImage("assets/Background/background_MYEYES.png")
    Background_Type = "Black"
    Font_1 = love.graphics.newFont(20)
    love.graphics.setFont(Font_1)
    love.graphics.getWidth()
    love.graphics.getHeight()
    love.window.setTitle("getting to the goal")
    love.graphics.setBackgroundColor(0, 0, 0)
    Bad_1 = love.graphics.newImage("assets/Enemy/enemy_1.png")
    Bad_2 = love.graphics.newImage("assets/Enemy/enemy_2.png")
    Bad_3 = love.graphics.newImage("assets/Enemy/enemy_3.png")
    Bad_4 = love.graphics.newImage("assets/Enemy/enemy_4.png")
    Bad_5 = love.graphics.newImage("assets/Enemy/enemy_5.png")
    Bad_6 = love.graphics.newImage("assets/Enemy/enemy_6.png")
    fullscreenonce = false
    MYEYESonce = false
    Player:load()
    Player_Hitbox:load()
    Menu:load()
    Menu_Hitbox:load()
    Goal:load()
    Level_load:load()
end

function love.update(dt)
    if Level_num == 1 then
        Game_Music:play()
    else
        Game_Music:stop()
    end
    if Level_num > 1 then
        Game_MainMusic:play()
    else
        Game_MainMusic:stop()
    end
    if Player.Alive == false then
        Player_DeathSound:play()
    end
    Player:update(dt)
    Player_Hitbox:update(dt)
    Menu:update(dt)
    Menu_Hitbox:update(dt)
    Goal:update(dt)
    Level_load:update(dt)
    if love.window.getFullscreen() == true and fullscreenonce == false then
        Player:load()
        Player_Hitbox:load()
        Menu:load()
        Menu_Hitbox:load()
        Goal:load()
        Level_load:load()
        fullscreenonce = true
    elseif love.window.getFullscreen() == false and fullscreenonce then
        Player:load()
        Player_Hitbox:load()
        Menu:load()
        Menu_Hitbox:load()
        Goal:load()
        Level_load:load()
        fullscreenonce = false
    end
    if MY_EYES and MYEYESonce == false then
        Bad_1 = love.graphics.newImage("assets/MY_EYES/Enemy/enemy_1.png")
        Bad_2 = love.graphics.newImage("assets/MY_EYES/Enemy/enemy_2.png")
        Bad_3 = love.graphics.newImage("assets/MY_EYES/Enemy/enemy_3.png")
        Bad_4 = love.graphics.newImage("assets/MY_EYES/Enemy/enemy_4.png")
        Bad_5 = love.graphics.newImage("assets/MY_EYES/Enemy/enemy_5.png")
        Bad_6 = love.graphics.newImage("assets/MY_EYES/Enemy/enemy_6.png")
        Player:load()
        Player_Hitbox:load()
        Goal:load()
        Level_load:load()
        MYEYESonce = true
    elseif MY_EYES == false and MYEYESonce == true then
        Bad_1 = love.graphics.newImage("assets/Enemy/enemy_1.png")
        Bad_2 = love.graphics.newImage("assets/Enemy/enemy_2.png")
        Bad_3 = love.graphics.newImage("assets/Enemy/enemy_3.png")
        Bad_4 = love.graphics.newImage("assets/Enemy/enemy_4.png")
        Bad_5 = love.graphics.newImage("assets/Enemy/enemy_5.png")
        Bad_6 = love.graphics.newImage("assets/Enemy/enemy_6.png")
        Player:load()
        Player_Hitbox:load()
        Goal:load()
        Level_load:load()
        MYEYESonce = false
    end
    if MY_EYES then
        Background_Type = "MY EYES"
    else
        Background_Type = "Black"
    end
end

function love.draw()
    if Background_Type == "Red" then
        love.graphics.draw(Background_Red, 0, 0)
    elseif Background_Type == "MY EYES" then
        love.graphics.draw(Background_MYEYES, 0, 0)
    else
        love.graphics.draw(Background_Black, 0, 0)
    end
    Player:draw()
    Player_Hitbox:draw()
    Menu_Hitbox:draw()
    Goal:draw()
    Level_load:draw()
    if MY_EYES then
        love.graphics.setColor(0, 0, 0)
        love.graphics.print("level "..Level_num, 0, 0)
        love.graphics.setColor(1, 1, 1)
    else
        love.graphics.print("level "..Level_num, 0, 0)
    end
    if Player.Alive == false and MY_EYES == false then
        love.graphics.print("you died...", love.graphics.getWidth() / 2, love.graphics.getHeight() / 2)
    end
    Menu:draw()
end


-- i looked at this for an hour trying to figure out some stupid error
function checkCollision(x1, y1, width1, height1, x2, y2, width2, height2)
    if x1 + width1 > x2 and x1 < x2 + width2 and y1 + height1 > y2 and y1 < y2 + height2 then
        PlayerDieDie()
        return true
    else
        return false
    end
end

function PlayerNoise()
    Player_Noise:play() 
end

function PlayerDieDie()
    if Player_Hitbox.xpos + Player_Hitbox.Width > Goal.xpos and Player_Hitbox.xpos < Goal.xpos + Goal.Width and Player_Hitbox.ypos + Player_Hitbox.Height > Goal.ypos and Player_Hitbox.ypos < Goal.ypos + Goal.Height then
    print()
    else
        Player_ISDED:play()
    end
end

function ResetLevelDataOrSomething()
    three_load = 0
    four_load = 0
    five_load = 0
    six_load = 0
    seven_load = 0
    eight_load = 0
    nine_load = 0
    ten_load = 0
    twelve_load = 0
    thirteen_load = 0
    fourteen_load = 0
    fifteen_load = 0
    sixteen_load = 0
    seventeen_load = 0
    eighteen_load = 0
    nineteen_load = 0
    twenty_load = 0
    twentyone_load = 0
    twentytwo_load = 0
    twentythree_load = 0
    twentyfour_load = 0
    twentyfive_load = 0
    twentysix_load = 0
    twentyseven_load = 0
    twentyeight_load = 0
    twentynine_load = 0
    thirty_load = 0
end

function resetcheckpoints()
    Checkpoint_1 = false
    Checkpoint_2 = false
    Checkpoint_3 = false
    Checkpoint_4 = false
end