require("scripts/Goal")
require("levels/Level_Var")

Player = {}

function Player:load()
    Player.Alive = true
    PlayerImage = love.graphics.newImage("assets/Player/player.png")
    Player.xpos = love.graphics.getWidth() / 2 - 64
    Player.ypos = love.graphics.getHeight() - 64
    Player.area = 64
    Player.Speed = 300
end

function Player:update(dt)
    if Player.Alive then
        if Menu.on == false then
            if love.keyboard.isDown("w") or love.keyboard.isDown("up") then 
                Player.ypos = Player.ypos - Player.Speed * dt
            end
            if love.keyboard.isDown("s") or love.keyboard.isDown("down") then
                Player.ypos = Player.ypos + Player.Speed * dt
            end
            if love.keyboard.isDown("d") or love.keyboard.isDown("right") then
                Player.xpos = Player.xpos + Player.Speed * dt
            end
            if love.keyboard.isDown("a") or love.keyboard.isDown("left") then
                Player.xpos = Player.xpos - Player.Speed * dt
            end
        end
    end
    if love.window.getFullscreen() == false then
        Player.Speed = 300
    else
        Player.Speed = 350
    end
    if MY_EYES then
        PlayerImage = love.graphics.newImage("assets/MY_EYES/Player/Player_MYEYES.png")
    elseif MY_EYES == false then
        PlayerImage = love.graphics.newImage("assets/Player/player.png")
    end
end

function Player:draw()
    if Player.Alive then
        love.graphics.draw(PlayerImage, Player.xpos, Player.ypos)
    end
end

Player_Hitbox = {}

function Player_Hitbox:load()
    Player_Hitbox.xpos = Player.xpos
    Player_Hitbox.ypos = Player.ypos
    Player_Hitbox.Size = 64
    Player_Hitbox.Width = Player_Hitbox.Size
    Player_Hitbox.Height = Player_Hitbox.Size
end

function Player_Hitbox:update(dt)
    Player_Hitbox:checkBoundaries()
    Player_Hitbox.xpos = Player.xpos
    Player_Hitbox.ypos = Player.ypos
    Player_Hitbox:checkBoundaries()
    if checkCollision(Player_Hitbox.xpos, Player_Hitbox.ypos, Player_Hitbox.Width, Player_Hitbox.Height, Goal.xpos, Goal.ypos, Goal.Width, Goal.Height) then
        Level_Var:uponelevel()
    end
end

function Player_Hitbox:draw()
    love.graphics.rectangle("line", Player_Hitbox.xpos, Player_Hitbox.ypos, Player_Hitbox.Width, Player_Hitbox.Height)
end

function Player_Hitbox:checkBoundaries()
    if Player.ypos < 0 then
        Player.ypos = 0
        PlayerNoise()
    elseif Player.ypos + Player_Hitbox.Height > love.graphics.getHeight() then
        Player.ypos = love.graphics.getHeight() - Player_Hitbox.Height
        PlayerNoise()
    end
    if Player.xpos < 0 then
        Player.xpos = 0
        PlayerNoise()
    elseif Player.xpos + Player_Hitbox.Width > love.graphics.getWidth() then
        Player.xpos = love.graphics.getWidth() - Player_Hitbox.Width
        PlayerNoise()
    end
end